(*******************************************************************************
Auteur : Pascal Magazine
Date: nov 2019
Content: day's counting between to dates routines
Update:
info: MonthDays from unit datih.inc from System unit

type
  PDayTable = ^TDayTable;
  TDayTable = array[1..12] of Word;
Const           { True ==> Leapyear }
  MonthDays : array [Boolean] of TDayTable =
   ((31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31),
    (31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31));

*******************************************************************************)

unit dateutils;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Dialogs;

Function DAYS_to_end_month(date: TDateTime): Word;

implementation

(* DAYS_to_end_month geeft aantal dagen vanaf een dag in de maand tot einde van
   die maand terug. Houdt rekening met een eventueel schrikkeljaar
*)
Function DAYS_to_end_month(date: TDateTime) : Word;
  var Year, Month, Day: word;
begin
  DecodeDate(Date, Year, Month, Day);
  Result := (MonthDays[IsLeapYear(Year) ,Month] - (Day)) ;
  Showmessage('days count to end Month = '+ IntToStr(Result));
end;

//-Same year  ------------------------------------------------------------
Function DAYS_OF_MONTH_COUNT(startdate,enddate:TDateTime): Word;
  var startYear, startMonth, startDay: word;
      endYear,   endMonth,   endDay:   word;
      month_count, days_count : word;
begin
  DecodeDate(startDate, startYear, startMonth, startDay);
  DecodeDate(Enddate, endYear, endMonth, endDay);
  month_count:=(startMonth +1) ;
  days_count := 0;

  if startdate = enddate then // vallen in het zelfde jaar
  Begin
    while month_count < EndMonth do
    begin
      days_count := (days_count + MonthDays[IsLeapYear(startYear),month_count]);
      inc(month_count);
    end;
  end
  else // vallen niet in het zelfde jaar
  begin
    while month_count <= 12 do
    begin
      days_count := (days_count + MonthDays[IsLeapYear(startYear),month_count]);
      inc(month_count);
    end;
  end;

//days_count := Days_count + FutureDays ;
Result := days_count ;
Showmessage('days count same year = '+ IntToStr(Result));
end;

Function Yearcount(startdate,enddate:TDateTime): Word;
var Year : Word;
    DaysCount : word;
var startYear, startMonth, startDay: word;
    endYear,   endMonth,   endDay:   word;

begin
  DecodeDate(startDate, startYear, startMonth, startDay);
  DecodeDate(Enddate, endYear, endMonth, endDay);

  DaysCount := 0;
  Year := startYear;

  inc(Year);
  while Year < EndYear do
  begin
    if IsLeapYear(Year) then
    begin
      dayscount := (dayscount + 366)   ;
 //     Showmessage('leapyear = ' + IntToStr(SingleYear));
    end
    else
      dayscount := (dayscount + 365) ;

    inc(Year);
//    Showmessage('single year Function = ' + IntToStr(SingleYear));
  end;
  Result := DaysCount;

   {De schrikkeldag valt in de Gregoriaanse kalender op 29 februari
   en komt voor als het jaartal restloos deelbaar is door 4,
   maar niet door 100 – tenzij het jaartal restloos deelbaar door 400 is.
   Zo waren 2004, 2008, 2012 en 2016 (allemaal deelbaar door 4,
   maar niet door 100) schrikkeljaren. Ook 1600 (deelbaar door 400)
   was een schrikkeljaar. 1700, 1800 en 1900 waren dat niet
   deelbaar door 100, maar niet door 400) en 2000 weer wel. }
end;


end.

