(*******************************************************************************
Author : Blaise Pascal Magazine
Date: 10 nov 2019
Content: day's counting between to dates routines
Update:

info:
   MonthDays from unit datih.inc from SysUtils.pas  unit
   the code si shown in dati.inc
   dateutils.inc from dateutils.pas from package rtl_objpas\src\inc\dateutils.pp

type
  PDayTable = ^TDayTable;
  TDayTable = array[1..12] of Word;
Const           { True ==> Leapyear }
  MonthDays : array [Boolean] of TDayTable =
   ((31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31),
    (31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31));

*******************************************************************************)

unit DaysCount;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, ExtCtrls;

type
  TDaysBetweenYears = Class(TObject)
  private
    Fstartdate: TDateTime;
    Fenddate:   TDateTime;
    YS,MS,DS,       // S = Start (Year,Month,Day)
    YE,ME,DE: word; // E = End (Year,Month,Day)
  public
    FYears,
    FMonths,
    FDays:   Array[1..2] of word;
    FHours,
    FMins,
    FSecs,
    FMsecs: word;
    constructor Create;
    destructor Done;
    Procedure SetStartDate(ADate:  TDateTime);
    Procedure SetEndDate (ADate:  TDateTime);
    Function GetEndDate : TDateTime;
    Procedure CountDays;

  end;


var
  DaysBetweenYears : TDaysBetweenYears;

Const
  nularr: array[1..2] of word = (0,0);

implementation

uses Dialogs;
//TNotifyEvent = procedure(Sender: TObject) of object;

Constructor TDaysBetweenYears.Create;

Begin;
  inherited;
  // innit Fdays ect counters
  FYears     := nularr; // FYears[1]= aantal Y, FYears[2]= to nr of days between
  FMonths    := nularr; // FMonths[1]= aantal M, FYears[2]= to nr of monts between
  FDays      := nularr; // FDays[1] losse dagen, FDays[2]= total days
  FHours     := 0;
  FMins      := 0;
  FSecs      := 0;
  FMSecs     := 0;
  Fstartdate := NOW;                   // start date for event
  Fenddate   := 0;  // end date for event
  DecodeDate(FstartDate, YS, MS, DS);
  //  DecodeDate  (FEnddate, YE, ME, DE);
  DecodeTime (Now,FHours,Fmins,FSecs,FMSecs);
  // remaining time of the day
  FHours     := 23-FHours;
  FMins      := 59-FMins;
  FSecs      := 60-FSecs;
End;

Destructor TDaysBetweenYears.Done;
Begin
  inherited;
End;

Procedure TDaysBetweenYears.SetStartDate(ADate:  TDateTime);
Begin
  FStartDate := ADate;
end;

Procedure TDaysBetweenYears.SetEndDate(ADate:  TDateTime);
Begin
  FEndDate := ADate;
  DecodeDate(FEndDate, YE, ME, DE);
end;

Function TDaysBetweenYears.GetEndDate : TDateTime;
Begin
  Result := FEndDate;
end;

Procedure TDaysBetweenYears.CountDays;
  var YCnt: word;  // Year counter
      YDays: word;
      MCnt: word;  // month counter
      DCnt: word;  // day counter
      i : Integer; //counter
      Yes : Boolean;  // used for Yes/No correct display Showmessages
begin
  DecodeDate  (FEnddate, YE, ME, DE);
 // enddate should not be in the past
  if (Fenddate >= Fstartdate) and Not((Fstartdate =0) or (Fenddate =0)) then
  Begin
    FDays := NulArr;   // innit
    Yes := False;

    if YS = YE then
(* ------------ data within the same year -------------------------------*)
    Begin
      FYears := NulArr; // no years in between
     // Same_Month_in_same_Year
      if MS = ME then
      Begin
        FMonths := NulArr; // no years in between
        FDays[1] := (DE - DS);
        FDays[2] := FDays[1];
       // Showmessage('1: days in same Month&Year = '+ IntToStr(FDays));
      end
      else // MS <> ME
      Begin
       // Days_To_End_Month_StartDate
        FDays[2] := (MonthDays[IsLeapYear(YS) ,MS] - (DS)) ;
        FDays[1] := Fdays[2];
         // Showmessage('2a: start: days to end Month. (Same Year) = '+ IntToStr(FDays));

       // Days_Of_Remaning_Months_Startdate
        MCnt := 0; //Innit
        DCnt := 0;
        Inc(MS);         // next'full' month as starting point
        while MS < ME do
        begin
         //  Inc(FDays,MonthDays[IsLeapYear(YS),MS]);
          Inc(DCnt,MonthDays[IsLeapYear(YS),MS]);
          Inc(FDays[2],DCnt);
          Inc(MCnt);
          Inc(MS);
          FMonths[1] := MCnt;
          FMonths[2] := DCnt;
          Yes := True;
        end;
        if Yes then
        Begin
          Yes := False;
          // Showmessage('2b: Plus: Days_Of_Remaining_Months. (Same Year) = '+ IntToStr(FDays));
        End;

        // at last: Adding_up_Days_of_last_month_from_Enddate
        Inc(FDays[1],DE);
        Inc(FDays[2],DE);
        // Showmessage('2c: Plus: Days Of Last Months. (Same Year) = '+ IntToStr(FDays));
      End; // else: MS <> ME
    End
    else

(* ------------ data vallen niet in het zelfde jaar --------------------------*)

    begin
      // Days_To_End_Month_StartDate
      FDays[2] := (MonthDays[IsLeapYear(YS) ,MS] - (DS)) ;
      FDays[1] := Fdays[2];
      // Showmessage('3a: start: days to end Month. (Diff. Years) = '+ IntToStr(FDays));

      MCnt := 0; //Innit
      DCnt := 0;
      Inc(MS);           // next 'full' month as starting point
      while MS <= 12 do
      begin
        Inc(FDays[2],MonthDays[IsLeapYear(YS),MS]);
        Inc(DCnt,MonthDays[IsLeapYear(YS),MS]);
        Inc(MS);
        Inc(MCnt);
        FMonths[1] := MCnt;
        FMonths[2] := DCnt;
        Yes := True;
      end;

      if Yes then
      Begin
        Yes := False;
        // Showmessage('3b: Plus: Days Of Remaining Months. (Diff. Years) = '+ IntToStr(FDays));
      End;

      // summarize days in between years
      YDays := 0; //innit
      YCnt := 0;
      Inc(YS);           // start the next year
      while YS < YE do   // ieterate in between years
      begin
       if IsLeapYear(YS) then
       Begin
         Inc(FDays[2],366);
         Inc(YDays,366);
       End
       else
       Begin
         Inc(FDays[2],365);
         Inc(YDays,365);
       end;
       Inc(YS);
       Inc(Ycnt);
       FYears[1] := Ycnt;
       FYears[2] := YDays;
       Yes := True;
      end;

      if Yes then
      Begin
        Yes := False;
      // Showmessage('3c: Plus: Days In Years between = '+ IntToStr(FDays));
      End;

     // Days_From_Begin_Year_To_EndDate_Month
      MCnt := FMonths[1];
      DCnt := FMonths[2];
      i := 1;  // jan startingpoint
      while i < ME do
      begin
        Inc(FDays[2],MonthDays[IsLeapYear(YE),i]);
        Inc(DCnt,MonthDays[IsLeapYear(YE),i]);
        Inc(MCnt);
        Inc(i);
        FMonths[1] := MCnt;
        FMonths[2] := DCnt;
        Yes := True;
      end;

      if Yes then
      Begin
        Yes := False;
        // Showmessage('3d: Plus: Month Days From Begin EndYear. (Diff. Years) = '+ IntToStr(FDays));
      End;

      // at last: Adding_up_Days_of_last_month_from_Enddate
      Inc(FDays[2],DE);  //tel op bij totaal
      Inc(FDays[1],DE);  //tel op bij restdagen
      // Showmessage('3e: Plus: Days Of Last Months. (Diff. Years) = '+ IntToStr(FDays));

    end;
  End;
end;

end.

