(*******************************************************************************
Auteur : Pascal Magazine
Date: nov 2019
Content: day's counting between to dates routines
Update:

info:
   MonthDays from unit datih.inc from SysUtils.pas  unit
   de code hiervan staat in dati.inc
   dateutils.inc from dateutils.pas from package rtl_objpas\src\inc\dateutils.pp

type
  PDayTable = ^TDayTable;
  TDayTable = array[1..12] of Word;
Const           { True ==> Leapyear }
  MonthDays : array [Boolean] of TDayTable =
   ((31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31),
    (31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31));

*******************************************************************************)
unit MyDateUtils;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, {DateUtils,} Dialogs;

type
  TDaysBetweenYears = Class(TObject)
  private
    startdate: TDateTime;
    enddate:   TDateTime;
    YS,MS,DS,       // S = Start (Year,Month,Day)
    YE,ME,DE: word; // E = End (Year,Month,Day)
  public
    Days : word;
    constructor Create;
    destructor Done;
    Procedure CountDays;
  end;

// ontwikkel functies ==> gecombineerd in TDaysBetweenYears.CountDays
Function Days_To_End_Month(startdate,enddate:TDateTime): Word;
Function Days_Of_Months(startdate,enddate:TDateTime): Word;
Function Days_In_Years(startdate,enddate:TDateTime): Word;
Function Days_From_Begin_Year_To_Date(date: TDateTime) : Word;

var
  DaysBetweenYears : TDaysBetweenYears;

implementation

Constructor TDaysBetweenYears.Create;
Begin;
  inherited;
  Days := 0; // innit days counter
  startdate := EncodeDate(2019,4,15); // start date for event
  enddate := EncodeDate(2020,4,28); // end date for event
  DecodeDate(startDate, YS, MS, DS);
  DecodeDate  (Enddate, YE, ME, DE);
End;

Destructor TDaysBetweenYears.Done;
Begin
  inherited;
End;

Procedure TDaysBetweenYears.CountDays;
  var MCnt: word;  // month counter
begin
  // enddate mag niet in het verleden liggen
  if enddate >= startdate then
  Begin
    Days := 0;
    if YS = YE then
// ------------ vallen in het zelfde jaar-----------------------------------
    Begin
     // Same Month
      if MS = ME then
      Begin
        Days := (DE - DS);
        Showmessage('1: days of Month = '+ IntToStr(Days));
      end
      else
      Begin
       // Days_To_End_Month_StartDate
        Days := (MonthDays[IsLeapYear(YS) ,MS] - (DS)) ;
        Showmessage('2a: days to end Month same Year = '+ IntToStr(Days));

      // Days_Of_Remaning_Months_Startdate
        Inc(MS); // volgende 'volle' maand als beginpunt nemen
        while MS < ME do
        begin
          Inc(Days,MonthDays[IsLeapYear(YS),MS]);
          Inc(MS);
        end;
        Showmessage('2b: Days_Of_Remaining_Months_same_Year = '+ IntToStr(Days));

      // at last: Count Days of last month from Enddate
        Inc(Days,DE);

        Showmessage('2c: Days_Of_Last_Months_same_Year = '+ IntToStr(Days));
      End // else
    End
    else
// ------------vallen niet in het zelfde jaar----------------------------------
    begin
      // Days_To_End_Month_StartDate
      Days := (MonthDays[IsLeapYear(YS) ,MS] - (DS)) ;
      Showmessage('3: days to end Month different Years = '+ IntToStr(Days));

      Inc(MS); // volgende 'volle' maand als beginpunt nemen
      while MS <= 12 do
      begin
        Inc(Days,MonthDays[IsLeapYear(YS),MS]);
        Inc(MS);
      end;

      // dagen van tussenliggende jaren er bij optellen
      Inc(YS);
      while YS < YE do
      begin
       if IsLeapYear(YS) then
         Inc(Days,366)
       else
         Inc(Days,365);

       Inc(YS);
      end;
      Showmessage('Days In Years between = '+ IntToStr(Days));

     // Days_From_Begin_Year_To_EndDate_Month
      MCnt := 1;  // jan als beginpunt nemen
      while MCnt < ME do
      begin
        Inc(Days,MonthDays[IsLeapYear(YE),MCnt]);
        Inc(MCnt);
      end;

      Showmessage('Month Days From Begin EndYear = '+ IntToStr(Days));
     // at last: Count Days of last month from Enddate
      Inc(Days,DE);

    end; // else: // vallen niet in het zelfde jaar


  End; // if enddate > startdate
end;



(* DAYS_to_end_month geeft aantal dagen vanaf een dag in de maand tot einde van
   die maand terug. Houdt rekening met een eventueel schrikkeljaar
*)
Function Days_To_End_Month(startdate,enddate:TDateTime): Word;
var YS, MS, DS,       // S = Start
    YE, ME, DE: word; // E = End
begin
  DecodeDate(startDate, YS, MS, DS);
  DecodeDate  (Enddate, YE, ME, DE);
  if ((MS = ME) AND (YS = YE)) then
  // Days To EndDay Same Month in same year
    Result := (DE - DS)
  else
  // Days_To_End_Month_StartDate
    Result := (MonthDays[IsLeapYear(YS) ,MS] - (DS)) ;
  Showmessage('days to end Month = '+ IntToStr(Result));
end;


(* Month_Days_From_Begin_Year geeft aantal dagen vanaf 1 jan tot de opgegeven dag
   van de opgegeven maand. Houdt rekening met een eventueel schrikkeljaar
*)
Function Days_From_Begin_Year_To_Date(date: TDateTime) : Word;
  var Y, M, D: word;
      Mcounter: word;  // month counter

begin
  DecodeDate(Date, Y, M, D);
  Mcounter := 1;  // jan als beginpunt nemen
  Result := 0;    // innit days counter

  while Mcounter < M do
  begin
    Inc(Result,MonthDays[IsLeapYear(Y),Mcounter]);
    Inc(Mcounter);
  end;
  // Count Days of last month
  Inc(Result,D);

  Showmessage('Month Days From Begin Year = '+ IntToStr(Result));
end;

//  Function DaysBetween(const ANow, AThen: TDateTime): Integer; //dateutil.inc

//-Same year  ------------------------------------------------------------
Function Days_Of_Months(startdate,enddate:TDateTime): Word;
  var YS, MS, DS,       // S = Start
      YE, ME, DE: word; // E = End
begin
  DecodeDate(startDate, YS, MS, DS);
  DecodeDate  (Enddate, YE, ME, DE);
  Inc(MS); // volgende 'volle' maand als beginpunt nemen
  Result := 0;      // innit days counter

  if YS = YE then // vallen in het zelfde jaar
  Begin
    while MS < ME do
    begin
      Inc(Result,MonthDays[IsLeapYear(YS),MS]);
      Inc(MS);
    end;
    Showmessage('Days_Of_Months_Count_same_Year = '+ IntToStr(Result));
  end
  else // vallen niet in het zelfde jaar
  begin
    while MS <= 12 do
    begin
      Inc(Result,MonthDays[IsLeapYear(YS),MS]);
      Inc(MS);
    end;
    Showmessage('Days_to_end_year = '+ IntToStr(Result));
  // dagen van tussenliggende jaren er bij optellen
    Inc(Result,Days_In_Years(startdate,enddate));
    Showmessage('Days Of Months plus Days of Years in between = '+ IntToStr(Result));
  end;
end;

Function Days_In_Years(startdate,enddate:TDateTime): Word;
var YS, MS, DS,           // ?S = Start
    YE, ME, DE: Word;      // ?E = End

begin
  DecodeDate(startDate, YS, MS, DS);
  DecodeDate  (Enddate, YE, ME, DE);

  Result := 0;  // Innit counter

  Inc(YS);
  while YS < YE do
  begin
    if IsLeapYear(YS) then
      Inc(Result,366)
    else
      Inc(Result,365);

    Inc(YS);
  end;

  Showmessage('Days In Years = '+ IntToStr(Result));

   {De schrikkeldag valt in de Gregoriaanse kalender op 29 februari
   en komt voor als het jaartal restloos deelbaar is door 4,
   maar niet door 100 – tenzij het jaartal restloos deelbaar door 400 is.
   Zo waren 2004, 2008, 2012 en 2016 (allemaal deelbaar door 4,
   maar niet door 100) schrikkeljaren. Ook 1600 (deelbaar door 400)
   was een schrikkeljaar. 1700, 1800 en 1900 waren dat niet
   deelbaar door 100, maar niet door 400) en 2000 weer wel. }
end;


end.

