unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, ExtCtrls, Graphics, Dialogs,
  StdCtrls, MaskEdit, Calendar, ExtDlgs;

type

  { TFrmCountDown }

  TFrmCountDown = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Label1: TLabel;
    LblRestDays: TLabel;
    LblMonthsDays: TLabel;
    Label2: TLabel;
    LBLYearsDays: TLabel;
    Label9: TLabel;
    LblDaysRest: TLabel;
    LEndDate: TLabel;
    LTodaysDate: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LTodaysTime: TLabel;
    Label8: TLabel;

    LblDate: TLabel;
    LblTime: TLabel;

    LCountdownYear: TLabel;
    LCountdownMonth:   TLabel;
    LCountdownDays: TLabel;
    LCountdownHours: TLabel;
    LCountdownMinutes: TLabel;
    LCountdownSeconds: TLabel;

    Panel1: TPanel;
    TimerDayscount: TTimer;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure TimerDayscountTimer(Sender: TObject);
  public

  end;

var
  FrmCountDown: TFrmCountDown;

implementation

{$R *.lfm}

 uses Mainform, DaysCount;


    {The leap day falls in the Gregorian calendar on February 29
    and occurs if the year is divisible by 4,
    but not by 100 - unless the year is divisible by 400.
    For example, 2004, 2008, 2012 and 2016 (all divisible by 4,
    but not by 100) leap years. Also 1600 (divisible by 400)
    was a leap year. 1700, 1800 and 1900 were not
    divisible by 100, but not by 400) and 2000 again. }


///---------------------------------------------------
procedure TFrmCountDown.FormCreate(Sender: TObject);
begin
  LblDate.Caption:= DateToStr(Now);
  LblTime.Caption:= TimeToStr(Now);

  height:= 49;
  width := 605;
  BorderStyle:= bsNone;

end;

procedure TFrmCountDown.Image1DblClick(Sender: TObject);
begin
  BorderStyle:= bsDialog;
end;

procedure TFrmCountDown.Image2Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TFrmCountDown.FormClose(Sender: TObject; var CloseAction: TCloseAction
  );
begin
  FrmEnterDate.Close;
end;

procedure TFrmCountDown.TimerDayscountTimer(Sender: TObject);
var Hourdummy,
    MinDummy : word;
begin
  With DaysBetweenYears do
  Begin

    Dec(FSecs);
    if (FSecs = 0) then
    begin
     // sync time
      DecodeTime (Now,Hourdummy,MinDummy,FSecs,FMSecs);
     // if FMSecs will be used you should replace FSecs := 60 - FSEcs by 59
      FSecs := 60-FSecs;
      if (FMins <> 0) then
        Dec(FMins)
      else
      Begin
        FMins := 59;

        if (FHours <> 0) then
          dec(FHours)
        else
        Begin
          FHours := 23;
          if (FDays[2] <> 0) then
            dec(FDays[2])
          else
          Begin
            if FDays[2] = 0 then
              if FHours = 0 then
                if FMins = 0 then
                  FrmCountDown.Close;
          end;
        end;
      end;
    end;

    LCountdownDays.Caption:=IntToStr(FDays[2]);
    LCountdownHours.Caption:=IntToStr(FHours);
    LCountdownMinutes.Caption:=IntToStr(FMins);
    LCountdownSeconds.Caption:=IntToStr(FSecs);

  End;
  LblTime.Caption:= TimeToStr(Now);
end;

end.


